////////////////////////////////////////////////////////////////////////////////////////////////
window.addEventListener("message", function (event) {

  if (event.data && event.data.type && event.data.text.length) {
    var rqst = event.data;
    chrome.extension.sendMessage(rqst, function () { });
  }
}, false);
////////////////////////////////////////////////////////////////////////////////////////////////
function logMessage(str) {
   console.log(str);
}
////////////////////////////////////////////////////////////////////////////////////////////////
function getCntntScriptAsTag() {

  var script = document.createElement("script");
  script.type = "text/javascript";
  script.src = chrome.extension.getURL('cs.js?injectd');
  return script;

}
////////////////////////////////////////////////////////////////////////////////////////////////

var isFirstClk = false;
var isInjctd = false;
var selChange = false;

var babyCS = {
  ///////////////////////////////////////////////////////////////////////////////////////////////
  trim: function (capt) {
    if (capt.txt != null) {
      var ret = capt.txt.replace(/(^\s*)/, "");
      capt.ofst -= capt.txt.length - ret.length;
      capt.txt = ret.replace(/(\s*$)/, "");
    }
  },

  ////////////////////////////////////////////////////////////////////////////////////////////////
  start: function (doc) {
    doc.onmousedown = babyCS.mousedown;
    doc.onmouseup = babyCS.mouseup;
    doc.oncontextmenu = babyCS.ctxmnu;
    doc.onselectionchange = babyCS.selectionchange;

    var scrpts = document.scripts;
    for (var i = 0; i < scrpts.length ; i++) {
      if (scrpts[i].src.indexOf("cs.js?injectd") > 0) {
        logMessage('start: scrpts[' + i + '].src: ' + scrpts[i].src);
        isFirstClk = true;
        isInjctd = true;
      }
    }
  },
  ////////////////////////////////////////////////////////////////////////////////////////////////
  mousedown: function (e) {
    logMessage("---------- mouse down ------------------");
    // filter middle button
    if (e.button != 1)
      babyCS.getText(e);
  },
  ////////////////////////////////////////////////////////////////////////////////////////////////
  mouseup: function (e) {
    logMessage("---------- mouse up --------------------");
    // for middle click with scroll
    if ((e.button == 1) || (e.target.tagName == "INPUT") || isFirstClk) {
      babyCS.getText(e);
      isFirstClk = false;
      return;
    }

    if (e.button == 0 && selChange)    
    {
      babyCS.getSelection();
      selChange = false;
    }
  },
  ////////////////////////////////////////////////////////////////////////////////////////////////
  ctxmnu: function (e) {
    // prevent ctx menu ctrl-rightclick
    return !(e.ctrlKey)
  },
  ////////////////////////////////////////////////////////////////////////////////////////////////
  selectionchange : function(e) {
    logMessage("---------- selectionchange  -------------------");
    //for text selection
    selChange = true;
  },
  ////////////////////////////////////////////////////////////////////////////////////////////////
  getText: function (e) {
    /*
    Babylon client values
    modifier:
    Shift = 0
    Ctrl  = 1
    Alt   = 2
    None  = 3
    mouse button:
    right click  = 0
    middle click = 1
    left click   = 2
    */
    var modifierKey = 3; // none
    var mouseButton = 2; // left

    if (e.ctrlKey)
      modifierKey = 1;
    else if (e.shiftKey)
      modifierKey = 0;
    else if (e.altKey)
      modifierKey = 2;

    if (e.button == 0)    // left click
      mouseButton = 2;
    else if (e.button == 2)  //right click
      mouseButton = 0;
    else if (e.button == 1)  //middle click
      mouseButton = 1;

    // ignore left & right click without modifier
    if (modifierKey == 3 && (mouseButton == 0 || mouseButton == 2))
      return;

    if (document.caretRangeFromPoint == null)
      return;

    var capt = {
      txt: "",
      ofst: 0
    };

    var rng = document.caretRangeFromPoint(e.clientX, e.clientY);
    if (!rng) {
      logMessage("FAILED: caretRangeFromPoint");
    }
    else if (rng.commonAncestorContainer.parentElement != e.target && !isInjctd) {
      try {
        capt.txt = e.target.value;
        if (e.target.tagName == "IFRAME" && e.target.modified == null) {
          e.target.modified = true;
          var ifrmDoc = e.target.contentDocument;
          //append Head
          ifrmDoc.firstChild.firstChild.appendChild(getCntntScriptAsTag());
          return;
        }

        else if (capt.txt && (e.target.selectionStart < capt.txt.length)) {
          capt.ofst = e.target.selectionStart;
          logMessage("getText: captOfst: " + capt.ofst);
        }
      }
      catch (e) { };
    }
    else if (rng.startOffset >= rng.commonAncestorContainer.textContent.length) {
      logMessage("empty - start offset greater or equal than common ancestor");
    }
    else {
      logMessage("all other ");
      capt.txt = rng.commonAncestorContainer.textContent;
      capt.ofst = rng.startOffset;
    }

    babyCS.trim(capt);
    if (capt.txt == "")
      capt.ofst = 0;
    else if (capt.ofst >= capt.txt.length) {
      logMessage("in length fix");
      capt.ofst = capt.txt.length - 1;
    }

    var rqst = {
      type: "getText",
      text: capt.txt,
      offset: capt.ofst,
      modifier: modifierKey,
      mouseButton: mouseButton
    };

    if (rng)
      rng.detach();

    logMessage("send request - getText: " + rqst.text + "(" + rqst.offset + "), button: " + rqst.mouseButton + ", modifier: " + rqst.modifier);

    if (!isInjctd)
      chrome.extension.sendMessage(rqst, function () { });
    else
      location.href = "javascript:parent.postMessage(" + (JSON.stringify(rqst)) + ", '*');";
  },

  ////////////////////////////////////////////////////////////////////////////////////////////////
  getSelection: function() {

    //store selected text
    var sel = window.getSelection();
    if (sel == null)
      return;

    var selText = sel.toString();
    if (selText.length < 2)
      return;

    // prepare data for background page
    var rqst = {
      type: "getSelection",
      text: selText
    };

    logMessage("send request - getSelection: " + rqst.text);

    if (!isInjctd)
      chrome.extension.sendMessage(rqst, function () { });
    else
      location.href = "javascript:parent.postMessage(" + (JSON.stringify(rqst)) + ", '*');";
  }

  ////////////////////////////////////////////////////////////////////////////////////////////////
};// end of cntntScrpt

////////////////////////////////////////////////////////////////////////////////////////////////
babyCS.start(document);